// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.25.0
// source: patient_records.sql

package db

import (
	"context"
)

const createPatient_record = `-- name: CreatePatient_record :one
INSERT INTO patient_records (
    title,
    anamnesis,
    patient_id
) VALUES (
    $1, $2, $3
) RETURNING id, title, created_at, anamnesis, patient_id
`

type CreatePatient_recordParams struct {
	Title     string `json:"title"`
	Anamnesis string `json:"anamnesis"`
	PatientID int64  `json:"patient_id"`
}

func (q *Queries) CreatePatient_record(ctx context.Context, arg CreatePatient_recordParams) (PatientRecords, error) {
	row := q.db.QueryRowContext(ctx, createPatient_record, arg.Title, arg.Anamnesis, arg.PatientID)
	var i PatientRecords
	err := row.Scan(
		&i.ID,
		&i.Title,
		&i.CreatedAt,
		&i.Anamnesis,
		&i.PatientID,
	)
	return i, err
}

const deletePatient_record = `-- name: DeletePatient_record :exec
DELETE FROM patient_records WHERE id = $1
`

func (q *Queries) DeletePatient_record(ctx context.Context, id int64) error {
	_, err := q.db.ExecContext(ctx, deletePatient_record, id)
	return err
}

const getPatient_record = `-- name: GetPatient_record :one
SELECT id, title, created_at, anamnesis, patient_id FROM patient_records
WHERE id = $1 LIMIT 1
`

func (q *Queries) GetPatient_record(ctx context.Context, id int64) (PatientRecords, error) {
	row := q.db.QueryRowContext(ctx, getPatient_record, id)
	var i PatientRecords
	err := row.Scan(
		&i.ID,
		&i.Title,
		&i.CreatedAt,
		&i.Anamnesis,
		&i.PatientID,
	)
	return i, err
}

const listPatient_records = `-- name: ListPatient_records :many
SELECT id, title, created_at, anamnesis, patient_id FROM patient_records
ORDER BY id
LIMIT $1
OFFSET $2
`

type ListPatient_recordsParams struct {
	Limit  int64 `json:"limit"`
	Offset int64 `json:"offset"`
}

func (q *Queries) ListPatient_records(ctx context.Context, arg ListPatient_recordsParams) ([]PatientRecords, error) {
	rows, err := q.db.QueryContext(ctx, listPatient_records, arg.Limit, arg.Offset)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []PatientRecords
	for rows.Next() {
		var i PatientRecords
		if err := rows.Scan(
			&i.ID,
			&i.Title,
			&i.CreatedAt,
			&i.Anamnesis,
			&i.PatientID,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const updatePatient_record = `-- name: UpdatePatient_record :exec
UPDATE patient_records
SET title = $2
WHERE id = $1
`

type UpdatePatient_recordParams struct {
	ID    int64  `json:"id"`
	Title string `json:"title"`
}

func (q *Queries) UpdatePatient_record(ctx context.Context, arg UpdatePatient_recordParams) error {
	_, err := q.db.ExecContext(ctx, updatePatient_record, arg.ID, arg.Title)
	return err
}
